'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useDebounce;
var React = require('react');
var useDebouncedCallback = require('./callback').default;

function useDebounce(value, delay) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var debouncedState = React.useState(value);
  var debouncedCallback = useDebouncedCallback(function (value) {
    return debouncedState[1](value);
  }, delay, options);

  React.useEffect(function () {
    if (debouncedState[0] !== value) {
      debouncedCallback[0](value);
    }
  });

  return [debouncedState[0], debouncedCallback[1]];
}